// Bounce.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

LONG threadcount = 0;
volatile BOOL running = TRUE;
CONSOLE_SCREEN_BUFFER_INFO csbi;    /* Console information structure */
HANDLE Complete;

/* GetRandom returns a random integer between min and max. */
#define GetRandom( min, max ) (((rand() >> 8) % (int)(((max) + 1) - (min))) + (min))

/****************************************************************************
*                                   Bounce
* Inputs:
*       LPVOID p: (LPVOID)(TCHAR) character to display
* Result: void
*       
* Effect: 
*       Bounces a character around
****************************************************************************/

void Bounce(LPVOID p)
    {
     _TCHAR ch = (char)p;

     /* Generate letter and color attribute from thread argument. */
     _TCHAR    blankcell = _T(' ');
     BOOL    first = TRUE;
     COORD   oldcoord;
     COORD   newcoord;
     DWORD   result;
     HANDLE  hStdOut = GetStdHandle( STD_OUTPUT_HANDLE );


    /* Seed random number generator and get initial location. */
    srand( _threadid );
    newcoord.X = GetRandom( 0, csbi.dwSize.X - 1 );
    newcoord.Y = GetRandom( 0, csbi.dwSize.Y - 1 );
    while( running )
       {
        /* Pause between loops. */
        Sleep( 100L );

        /* Blank out our old position on the screen, and draw new letter. */
        if( first )
           first = FALSE;
        else
           WriteConsoleOutputCharacter( hStdOut, &blankcell, 1, oldcoord, &result );

        WriteConsoleOutputCharacter( hStdOut, &ch,        1, newcoord, &result );

        /* Increment the coordinate for next placement of the block. */
        oldcoord.X = newcoord.X;
        oldcoord.Y = newcoord.Y;
        newcoord.X += GetRandom( -1, 1 );
        newcoord.Y += GetRandom( -1, 1 );

        /* Correct placement (and beep) if about to go off the screen. */
        if( newcoord.X < 0 )
            newcoord.X = 1;
        else if( newcoord.X == csbi.dwSize.X )
            newcoord.X = csbi.dwSize.X - 2;
        else if( newcoord.Y < 0 )
            newcoord.Y = 1;
        else if( newcoord.Y == csbi.dwSize.Y )
            newcoord.Y = csbi.dwSize.Y - 2;

        /* If not at a screen border, continue, otherwise beep. */
        else
            continue;
        Beep( (ch - 'A') * 100, 175 );
       }
     if(!first)
        WriteConsoleOutputCharacter( hStdOut, &blankcell, 1, oldcoord, &result );

     LONG count = InterlockedDecrement(&threadcount);
     if(count == 0)
         SetEvent(Complete);
    }

/****************************************************************************
*                                  Launcher
* Inputs:
*       LPVOID dummy: unused parameter
* Result: UINT
*       Unused, 0
* Effect: 
*       Once a second launches a new thread with a new character code
****************************************************************************/

static UINT __stdcall Launcher(LPVOID dummy)
    {
     _TCHAR    ch = _T('A');
     Complete = CreateEvent(NULL, TRUE, FALSE, NULL);
     
     while(running)
        { /* start another thread */
         InterlockedIncrement(&threadcount);
         uintptr_t result = _beginthread(Bounce, 0, (LPVOID)ch);
         if(result == (uintptr_t)-1L)
             {
              InterlockedDecrement(&threadcount); 
              break;
             }
         ch++;
         if(!_istprint(ch))
            ch = _T('A');
         Sleep(1000);
        } /* start another thread */
     WaitForSingleObject(Complete, INFINITE);
     return 0;
    }

/****************************************************************************
*                                   _tmain
* Inputs:
*       argc: unused
*       argv: unused
* Result: int 
*       Unused, 0
* Effect: 
*       Runs the program.  
****************************************************************************/
int _tmain(int argc, _TCHAR* argv[])
   { 
    HANDLE hStdOut = GetStdHandle( STD_OUTPUT_HANDLE );

    /* Get display screen's text row and column information. */
    GetConsoleScreenBufferInfo( hStdOut, &csbi );

    UINT id;
    HANDLE launch = (HANDLE)_beginthreadex(NULL, 0, Launcher, NULL, 0, &id);

    _getch();
    running = FALSE;

    WaitForSingleObject(launch, INFINITE);
    CloseHandle(launch);
    return 0;
   }

